/*
******************************************************************************
File:     main.c
Info:     Generated by Atollic TrueSTUDIO(R) 6.0.0   2016-11-07

The MIT License (MIT)
Copyright (c) 2009-2016 Atollic AB

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
******************************************************************************
*/

/* Includes */
// je v Nucleo ... #include "stm32f4xx.h"
#include "stm_core.h"
#include "nucleo_usart.h"
#include "systick_ms.h"
#include "NEOpixel.h"

#include <stdlib.h>
#include <unistd.h>

int pocetRGB = 8;

void heapify(int pole[]);
void up(int pole[], int i);
void down(int pole[], int last);

int main(void)
{
  uint32_t tmBtn = 0, tmSleep = 0;
  int  intervalSleep = 100;

  bool bbButton, bbLastButton = true;

  bool roztrideno = true;
  bool cyklus = true;
  bool jasDOWN = false;
  bool firstX = true;
  bool swapped;
  bool pivotNastaven = false;
  bool zastavit = true;
  bool menu = true;
  bool Shift = false;
  bool HSLon = true;
  bool Ron = true;
  bool Gon = false;
  bool Bon = false;
  bool btnCasovacStart = true;
  bool start = true;
  bool nastavPocetRGB = false;

  int poleDEMO[NUM_PIXELS_MAX] = {105,20,230,48,75,141,25,15};
  int pole[NUM_PIXELS_MAX];
  int polePom[NUM_PIXELS_MAX];
  int poleIntervalSleep[4] = {100, 500, 1000, 2000};

  int algoritmus = 0;
  int algoritmusLast = 0;
  int pocetAlgoritmu = 5;
  int x = 0;
  int z = 0;
  int lastx = 10;
  int iShift;
  int btnCNT = 0;
  int volbaInt = 0;
  int vysledek = 0;

  SetClock100MHz(clockSourceHSI);
  SystemCoreClockUpdate();

  InitSystickDefault();

  Nucleo_SetPinGPIO(GPIOA, 5, ioPortOutputPP);
  Nucleo_SetPinGPIO(GPIOC, 13, ioPortInputPU);

  Usart2Init(38400);

  if (!NEOpixelInit(pocetRGB))
  {
    puts("zadano vice RGB nez je povoleno");

    puts("zadejte pocet RGB:");
    puts("'+' - +1 RGB");
    puts("'-' - -1 RGB");
    puts("' ' - nastavit zadany pocet RGB");
    while (1)
    {
      if (IsUsart2Recv())
      {
        char c = getchar();

        printf("pocet RGB je %d\n", pocetRGB);
        switch(c)
        {
          case '+':
            pocetRGB++;
            printf("pocet RGB je nastaven na %d\n", pocetRGB);
            break;
          case '-':
            pocetRGB--;
            printf("pocet RGB je nastaven na %d\n", pocetRGB);
            break;
          case ' ':
            nastavPocetRGB = true;
            break;
          default:
            putchar(c);
            break;
        }

      }
      if(nastavPocetRGB)
      {
        if(NEOpixelInit(pocetRGB))
        {
          printf("inicializace NeoPixel uspesne provedena pro %d RGB\n", pocetRGB);
          break;
        }
        else
          nastavPocetRGB = false;
      }
    }
  }
  else
    printf("inicializace NeoPixel uspesne provedena pro %d RGB\n", pocetRGB);


  for (int i = 0; i < numPixels; i++)
  {
    SetPixel(i, 0, 0, 0);

    pole[i] = 0;
  }
  curBit = 0;
  TIM3->CNT = TIM3->ARR;        // ihned to pretece (doufam)
  TIM3->CR1 |= TIM_CR1_CEN;

  /* Infinite loop */
  while (1)
  {
    if (CUR_TICKS > tmBtn)
    {
      tmBtn = CUR_TICKS + 10;

      bbButton = GPIORead(GPIOC, 13);
      btnCNT++;

      if (bbLastButton != bbButton)
      {
        bbLastButton = bbButton;
        if(btnCasovacStart)
        {
          btnCNT = 0;
          btnCasovacStart = false;
        }

        if (bbButton)       // edge to H
        {
          btnCasovacStart = true;
          if (btnCNT > 200)           //2s
          {
            if(zastavit)
            {
              zastavit = false;
              puts("trideni zahajeno");

              if (cyklus)
                puts("cyklus spusten");
              if (roztrideno)
                roztrideno = false;
            }
            else
            {
              zastavit = true;
              menu = true;
              if (cyklus)
                puts("cyklus zastaven");
              else
                puts("trideni zastaveno");
            }
          }

          if (btnCNT > 20 && btnCNT < 200)
          {
            if (volbaInt < 3)
              volbaInt++;
            else
              volbaInt = 0;

            intervalSleep = poleIntervalSleep[volbaInt];
            printf("cekaci doba byla zmenena na %d \n", intervalSleep);
          }

          if (btnCNT < 20)
          {
            if (algoritmus >= pocetAlgoritmu - 1)
              algoritmus = 0;
            else
              algoritmus++;
          }
        }
      }
    }

    if (menu)
    {
      menu = false;
      puts("\n.............nabidka moznosti.............");
      puts("' ' - zahajit/pozastavit trideni");
      puts("'p' - nastavit do pole hodnot hodnoty 105,20,230,48,75,141,25,15");
      puts("'r' - nastavit do pole hodnot nahodne hodnoty");
      puts("'c' - nastavit reim cyklus");
      puts("'j' - zmenit jas RGB");
      puts("'a' - zmena algoritmu");
      puts("'+' - zvetsit ekaci dobu mezi kroky o 50");
      puts("'-' - snizit cekaci dobu mezi kroky o 50");
      puts("'x' - prepnout rezim palety barev HSL/RGB");
      puts("'R' - zapnout R slozku RGB palety");
      puts("'G' - zapnout G slozku RGB palety");
      puts("'B' - zapnout B slozku RGB palety");
      puts("..........................................\n");

      puts(".........ovladani pomoci tlacitka.........");
      puts("stisknuti - zmena algoritmu");
      puts("stisknuti na 200ms - zmena cekaci doby mezi kroky na 100, 500, 1000, 2000");
      puts("stisknuti na 2s - zahajit/pozastavit trideni");
      puts("..........................................\n");

    }

    if (IsUsart2Recv())
    {
      char c = getchar();

      if(zastavit)
      {
        switch(c)
        {
          case 'r':
            puts("\nrandom pole:");
            for(int i = 0; i < numPixels; i++)
            {
              pole[i] = (rand() % (0 - 255 + 1));
              polePom[i] = pole [i];
              printf("%d, ", pole[i]);
            }

            Zobraz(pole, jasDOWN, HSLon, Ron, Gon, Bon);
            puts("");
            break;
          case 'p':
            puts("\nDEMO pole:");
            for(int x = 0;x < numPixels;x++)
            {
              pole[x] = poleDEMO[x];
              polePom[x]= poleDEMO[x];
              printf("%d, ", pole[x]);
            }

            Zobraz(pole, jasDOWN, HSLon, Ron, Gon, Bon);
            puts("");
            break;
          case 'c':
            cyklus=!cyklus;
            if (cyklus)
              puts("rezim cyklus zapnut");
            else
              puts("rezim cyklus vypnut");
            break;
          case 'a':
            firstX = true;
            for(int i = 0; i < numPixels; i++)
              pole[i] = polePom[i];
            if (algoritmus >= pocetAlgoritmu - 1)
              algoritmus = 0;
            else
              algoritmus++;
            break;
          default:
            break;
        }
      }
      switch(c)
      {
        case 'a':
        case 'r':
        case 'p':
        case 'c':
          break;
        case ' ':
          if (start)
          {
            for(int i = 0; i < numPixels; i++)
              pole[i] = poleDEMO[i];
            start = false;
          }
          if(zastavit)
          {
            zastavit = false;
            puts("trideni zahajeno");

            if (cyklus)
              puts("cyklus spusten");
            if (roztrideno)
              roztrideno = false;
          }
          else
          {
            zastavit = true;
            menu = true;
            if (cyklus)
              puts("cyklus zastaven");
            else
              puts("tdn zastaveno");
          }
          break;
        case 'j':
          jasDOWN = !jasDOWN;
          puts("jas byl zmenen");
          if(!roztrideno || zastavit)
            Zobraz(pole, jasDOWN, HSLon, Ron, Gon, Bon);
          break;
        case '+':
          intervalSleep += 50;
          printf("cekaci doba byla zvisena z %d na %d \n", intervalSleep-50, intervalSleep);
          break;
        case '-':
          if (intervalSleep > 100)
          {
            intervalSleep -= 50;
            printf("cekaci doba byla snizena z %d na %d \n", intervalSleep+50, intervalSleep);
          }
          else
          {
            intervalSleep = 100;
            puts("cekaci doba nezmenena... Dosazeno maximalni povolene rychlosti 100ms/krok");
          }
          break;
        case 'x':
          HSLon = !HSLon;
          if(HSLon)
            puts("rezim HSL barev zapnuty");
          else
            puts("rezim RGB barev zapnuty");
          Zobraz(pole, jasDOWN, HSLon, Ron, Gon, Bon);
          break;
        case 'B':
          if(!HSLon)
          {
            Bon = !Bon;
            if(Bon)
              puts("slozka B zapnuta");
            else
              puts("slozka B vypnuta");
            Zobraz(pole, jasDOWN, HSLon, Ron, Gon, Bon);
          }
          else
            puts("Slozka B nelze pridat, prtoze neni nastaven reim RGB");
          break;
        case 'R':
          if(!HSLon)
          {
            Ron = !Ron;
            if(Ron)
              puts("slozka R zapnuta");
            else
              puts("slozka R vypnuta");
            Zobraz(pole, jasDOWN, HSLon, Ron, Gon, Bon);
          }
          else
            puts("Slozka R nelze pridat, prtoe neni nastaven rezim RGB");
          break;
        case 'G':
          if(!HSLon)
          {
            Gon = !Gon;
            if(Gon)
              puts("slozka G zapnuta");
            else
              puts("slozka G vypnuta");
            Zobraz(pole, jasDOWN, HSLon, Ron, Gon, Bon);
          }
          else
            puts("Slozka G nelze pridat, prtoze neni nastaven rezim RGB");
          break;
        default:
          if ((c >= 0) && (c <= 127))
          {
            putchar(c);
          }
          else
            putchar('?');
          break;
      }
    }

    if(algoritmus!=algoritmusLast)
    {
      printf("byl zvolen algoritmus ");
      switch(algoritmus)
      {
        printf("vybran algoritmus: ");
        case 0:
          puts("SelectionSort");
          algoritmusLast = algoritmus;
          break;
        case 1:
          puts("BubbleSort");
          algoritmusLast = algoritmus;
          break;
        case 2:
          puts("InsertionSort");
          algoritmusLast = algoritmus;
          break;
        case 3:
          puts("HeapSort");
          algoritmusLast = algoritmus;
          break;
        case 4:
          puts("QuickSort");
          algoritmusLast = algoritmus;
          break;
        default:
          break;
      }
    }

    int temp, pozice, item, xBubble;
    int pivot, beg[NUM_PIXELS_MAX], end[NUM_PIXELS_MAX], L, R;

    if (CUR_TICKS > tmSleep)
    {
      tmSleep = CUR_TICKS + intervalSleep;

      x++;
      //if (zastavit)
      //  putchar('*');
      if (!zastavit)
      {
        if (!roztrideno)
        {
          xBubble++;
          if (!firstX)
          {
            if(algoritmus != 1)
              printf("x = %d \n",x);
            else
              printf("x = %d \n",xBubble);
          }
          else
            puts("x = 0");
        }
      }
    }

    if (!zastavit)
    {
      if (!roztrideno)
      {
        if(lastx!=x)
        {
          switch(algoritmus)
          {
            case 0:
              if (firstX)
              {
                x = 0;
                firstX = false;
              }
              temp = 0;

              pozice = numPixels - 1;
              for (int j = x; j < numPixels - 1; j++)
                  if (pole[pozice] > pole[j])          // hledani minima
                  {
                    pozice = j;

                  }
              // prohozeni prvku
              temp = pole[pozice];
              pole[pozice] = pole[x];
              pole[x] = temp;

              for (int i = 0; i<numPixels;i++)
              printf("%d, ", pole[i]);
              puts("\r");

              Zobraz(pole, jasDOWN, HSLon, Ron, Gon, Bon);
              lastx = x;


              if (x >= numPixels - 1)
              {

                roztrideno = true;
                firstX = true;
                puts("\r\npole: ");
                for (int i = 0; i<numPixels;i++)
                printf("%d, ", polePom[i]);
                puts("\r\n bylo roztrideno na:");
                for (int i = 0; i<numPixels;i++)
                printf("%d, ", pole[i]);
                puts("\r\n");
                if(!cyklus)
                {
                  zastavit = true;
                  menu = true;
                }
              }
              break;
            case 1:
              if (firstX)
              {
                x = 0;
                xBubble = 0;
                firstX = false;
                swapped = false;
              }
              pozice = numPixels - 2;
              temp = 0;

              // kontrola prohozeni
              bool konec = false;

              // prohozeni
              if (pole[x] > pole[x + 1])
              {
                  temp = pole[x];
                  pole[x] = pole[x + 1];
                  pole[x + 1] = temp;
                  swapped = true;

                  for (int i = 0; i<numPixels;i++)
                  printf("%d, ", pole[i]);
                  puts("\r");
                  Zobraz(pole, jasDOWN, HSLon, Ron, Gon, Bon);
                  lastx = x;
              }
              if (x > pozice && !swapped)
                konec = true;
              if (x > pozice)
              {
                x = 0;
                swapped = false;
              }
              pozice--;

              if(konec)
              {
                firstX = true;
                roztrideno = true;
                puts("\r\npole: ");
                for (int i = 0; i<numPixels;i++)
                printf("%d, ", polePom[i]);
                puts("\r\n bylo roztrideno na:");
                for (int i = 0; i<numPixels;i++)
                printf("%d, ", pole[i]);
                puts("\r\n");
                if(!cyklus)
                {
                  zastavit = true;
                  menu = true;
                }
              }
              break;
            case 2:
              if (firstX)
              {
                x = 0;
                firstX = false;
              }
              pozice = 0;
              // ulozeni prvku
              item = pole[x];
              pozice = x - 1;

              while ((pozice >= 0) && (pole[pozice] > item))
              {

                  pole[pozice + 1] = pole[pozice];
                  pozice--;
              }

              pole[pozice + 1] = item;

              for (int i = 0; i<numPixels;i++)
              printf("%d, ", pole[i]);
              puts("\r");

              Zobraz(pole, jasDOWN, HSLon, Ron, Gon, Bon);
              lastx = x;

              if(x > numPixels - 1)
              {
              roztrideno = true;
              firstX = true;
              puts("\r\npole: ");
              for (int i = 0; i<numPixels;i++)
              printf("%d, ", polePom[i]);
              puts("\r\n bylo roztrideno na:");
              for (int i = 0; i<numPixels;i++)
              printf("%d, ", pole[i]);
              puts("\r\n");
              if(!cyklus)
              {
                zastavit = true;
                menu = true;
              }
              }
              break;
            case 3:
              if (firstX)
              {
                x = 0;
                firstX = false;
                pozice = numPixels - 1;                   //posledni prvek
                heapify(pole);
              }
              temp = pole[0];                      // prohozen poslednho prvku s maximem
              pole[0] = pole[pozice];
              pole[pozice] = temp;
              pozice--;                          //nastaveni noveho posledniho prvku
              down(pole,pozice);

              for (int i = 0; i<numPixels;i++)
              printf("%d, ", pole[i]);
              puts("\r");

              Zobraz(pole, jasDOWN, HSLon, Ron, Gon, Bon);
              lastx = x;

              if (pozice <= 0)
              {
                firstX = true;
                roztrideno = true;
                puts("\r\npole: ");
                for (int i = 0; i<numPixels;i++)
                printf("%d, ", polePom[i]);
                puts("\r\nbylo roztrideno na:");
                for (int i = 0; i< numPixels ;i++)
                printf("%d, ", pole[i]);
                puts("\r\n");
                if(!cyklus)
                {
                  zastavit = true;
                  menu = true;
                }
              }
              break;
            case 4:
              if (firstX)
              {
                x = 0;
                z = 0;
                firstX = false;

                beg[0] = 0;
                end[0] = numPixels;
              }

              if (z >= 0)
              {
                if (!pivotNastaven)
                {
                L = beg[z];
                R = end[z] - 1;
                }
                if (L < R)
                {
                  if(!pivotNastaven)
                  {
                  pivot = pole[L];
                  pivotNastaven = true;
                  }
                    while (pole[R] >= pivot && L < R)
                      R--;
                    if (L < R)
                    {
                      pole[L++] = pole[R];

                      for (int i = 0; i<numPixels;i++)
                      printf("%d, ", pole[i]);
                      puts("\r");

                      Zobraz(pole, jasDOWN, HSLon, Ron, Gon, Bon);
                    }
                    while (pole[L] <= pivot && L < R)
                      L++;
                    if (L < R)
                    {
                      pole[R--] = pole[L];

                      for (int i = 0; i<numPixels;i++)
                      printf("%d, ", pole[i]);
                      puts("\r");

                      Zobraz(pole, jasDOWN, HSLon, Ron, Gon, Bon);
                    }

                  if (L >= R)
                  {
                  pole[L] = pivot;

                  for (int i = 0; i<numPixels;i++)
                  printf("%d, ", pole[i]);
                  puts("\r");

                  Zobraz(pole, jasDOWN, HSLon, Ron, Gon, Bon);

                  beg[z + 1] = L + 1;
                  end[z + 1] = end[z];
                  end[z++] = L;
                  pivotNastaven = false;
                  }
                }
                else
                {
                  z--;
                }
              }

              for (int i = 0; i<numPixels;i++)
              printf("%d, ", pole[i]);
              puts("\r");

              Zobraz(pole, jasDOWN, HSLon, Ron, Gon, Bon);
              lastx = x;


              if(z < 0)
              {
                firstX = true;
                roztrideno = true;
                puts("\r\npole: ");
                for (int i = 0; i<numPixels;i++)
                printf("%d, ", polePom[i]);
                puts("\r\nbylo roztrideno na:");
                for (int i = 0; i< numPixels ;i++)
                printf("%d, ", pole[i]);
                puts("\r\n");
                if(!cyklus)
                {
                  zastavit = true;
                  menu = true;
                }
              }
              break;
            default:
              break;
          }
        }
      }
    }

    if (!zastavit)
    {
      if(cyklus)
      {
        if(lastx != x)
        {
          if(roztrideno)
          {
            if(!Shift)
            {
              iShift = 0;
              if (algoritmus >= pocetAlgoritmu - 1)
                algoritmus = 0;
              else
                algoritmus++;

              Shift = true;
            }
            vysledek++;
            if (vysledek > 5)
            {
              ShiftPixels(pole,jasDOWN, iShift, HSLon, Ron, Gon, Bon);
              if(iShift == numPixels)
              {
                puts("\nrandom pole:");
                for(int i = 0; i < numPixels; i++)
                {
                  pole[i] = (rand() % (0 - 255 + 1));
                  polePom[i] = pole [i];
                  printf("%d, ", pole[i]);
                }
                puts("");

                Shift = false;
                roztrideno = false;
                vysledek = 0;
              }
              iShift++;
            }
            lastx = x;
          }
        }
      }
    }
  }
}

//-------------------------pomocn algoritmy pro tdn-------------------------------
    //--heapsort--
//oprava haldy nahoru
void  up(int pole[], int i)
{
    int child = i; //ulozim syna
    int parent, temp;
    while (child != 0)
    {
        parent = (child - 1) / 2; //otec
        if (pole[parent] < pole[child])
        { //detekce chyby
            temp = pole[parent]; //prohozeni syna s otcem
            pole[parent] = pole[child];
            pole[child] = temp;
            child = parent; //novy syn
        }
        else
          return;
    }
}

//oprava haldy dolu
void down(int pole[], int last)
{
    int parent = 0;
    int child, temp;
    while (parent * 2 + 1 <= last)
    {
        child = parent * 2 + 1;
        //pokud je vybran mensi syn
        if ((child < last) && (pole[child] < pole[child + 1]))
            child++; //vybereme toho vetsiho
        if (pole[parent] < pole[child])
        { //detekce chyby
            temp = pole[parent]; //prohozeni syna s otcem
            pole[parent] = pole[child];
            pole[child] = temp;
            parent = child; //novy otec
        }
        else
          return;
    }
}

// postaveni haldy z pole
void heapify(int pole[])
{
    for (int i = 1; i < numPixels; i++)
      up(pole, i);
}
//--heapsort--
