/*
 * nucleo_usart.c
 *
 *  Created on: 29. 3. 2021
 *      Author: honzi
 */
#include "mpp_shield.h"

void Usart2Init(int baudSpeed)
{
  setvbuf(stdout,NULL,_IONBF,0);
  setvbuf(stdin,NULL,_IONBF,0);

  if(!(RCC->APB1ENR & RCC_APB1ENR_USART2EN))
    {
      RCC->APB1ENR |= RCC_APB1ENR_USART2EN;
      RCC->APB1RSTR |= RCC_APB1RSTR_USART2RST;
      RCC->APB1RSTR &= ~RCC_APB1RSTR_USART2RST;
    }

    USART2->CR1 = USART_CR1_RE | USART_CR1_TE;
    USART2->CR2 = 0;
    USART2->CR3 = 0;

    //USART2->BRR = baudSpeed; //0x01A1 rychlost pri 38400 pri 16MHz
    {
    uint sampling = (USART2->CR1 & USART_CR1_OVER8) ? 8 : 16;
    uint32_t apb1, mant, tmp, frac;
    apb1 = GetBusClock(busClockAPB1);
    mant = apb1 * 16 / (sampling * baudSpeed); // v 16-tinach
    tmp = mant / 16;
    frac = mant - (tmp * 16); // zbytek po deleni 16
    USART2->BRR = (tmp << 4) | (frac & 0x0f);
    }

    USART2->CR1 |= USART_CR1_UE;    //povoleni bloku


    Nucleo_SetPinGPIO(GPIOA, 2, ioPortAlternatePP);
    Nucleo_SetAFGPIO(GPIOA, 2, 7);             //AF7 je USART2

    Nucleo_SetPinGPIO(GPIOA, 3, ioPortAlternatePP);
    Nucleo_SetAFGPIO(GPIOA, 3, 7);
    return;
}


int Usart2Send(char c)
{
  while (!(USART2->SR & USART_SR_TXE))        //cekej dokud neni volnz TDR
    ;
  USART2->DR = c;
  return c;
}

void Usart2String(char* txt)
{
  while(*txt)
  {
    Usart2Send(*txt);
    txt++;
  }
}

int Usart2Recv(void)
{
  while(!(USART2->SR & USART_SR_RXNE))
    ;

  return USART2->DR;
}

bool IsUsart2Recv(void)
{
  return (USART2->SR & USART_SR_RXNE) != 0;   //podminka vznuti true/false
}
