/*
 * stm_core.h
 *
 *  Created on: 22. 2. 2021
 *      Author: honzi
 */

#ifndef STM_CORE_H_
#define STM_CORE_H_

#include "stm32f4xx.h"
#include <stdbool.h>
#include <stdio.h>

#define BOARD_BTN_BLUE  GPIOC,13
#define BOARD_LED       GPIOA,5

typedef enum {
  ioPortOutputPP,       //vystup typu push-pull
  ioPortOutputOC,       //vystup typu Open Collector(Drain)
  ioPortAnalog,         //Analogovy vystup (pro prevodnik)
  ioPortInputFloat,     //vstup bez pull-up/down
  ioPortInputPU,        //vstup s pull-up
  ioPortInputPD,        //vstup s pull-down
  ioPortAlternatePP,    //alternativni vystup - push/pull
  ioPortAlternateOC,    //alternativni vystup - Open drain
}eIoPortModes;

typedef enum {
  busClockAHB,
  busClockAPB1,
  busClockAPB2,
  timersClockAPB1,
  timersClockAPB2
} eBusClocks;
uint32_t GetBusClock(eBusClocks clk);
uint32_t GetTimerClock(int timerNum);

typedef enum {
  clockSourceHSI,
  clockSourceHSE
} eClockSources;

bool SetClock100MHz(eClockSources clkSrc);
bool SetClockHSI(void);

bool Nucleo_SetPinGPIO(GPIO_TypeDef *gpio, uint32_t bitnum,eIoPortModes mode);
bool Nucleo_SetAFGPIO(GPIO_TypeDef *gpio, uint32_t bitnum, uint32_t afValue);
void GPIOToggle(GPIO_TypeDef *gpio, uint32_t bitnum);
bool GPIORead(GPIO_TypeDef *gpio, uint32_t bitnum);
void GPIOWrite(GPIO_TypeDef *gpio, uint32_t bitnum, bool state);

#endif /* STM_CORE_H_ */
